%Copyright (C) 2005  Tharreau-Taklidi
%This program is free software; you can redistribute it and/or
%modify it under the terms of the GNU General Public License
%as published by the Free Software Foundation; either version 2
%of the License, or (at your option) any later version.

%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.

function x = ifft2(f,line,column)

%   Calculate the two dimensional inverse discrete fast fourier transform
%
%   ifft2(f) returns the two-dimensional inverse Fourier transform
%   of matrix f.  If f is a vector, the result will have the same
%   orientation.
%
%   ifft2(f,line,column) pads matrix f with zeros to size [line  column]
%   before transforming.

if ((nargin == 1) || (nargin == 3))

	if (~strcmp(class(f),'double'))
    		f = double(f);
	end

    	f = conj(f);
    	
    	if nargin==1
        	x = conj(fft(fft(f,[],2),[],1))/(size(f,1)*size(f,2));
    	else
        	x = conj(fft(fft(f,column,2),line,1))/(line*column);
    	end

else
	disp("ifft2 error: number of imput argument incorect");
	disp("You must specify, one matrix argument only or matrix argument and column and line number"); 
end   

endfunction