%Copyright (C) 2005  Tharreau-Taklidi
%This program is free software; you can redistribute it and/or
%modify it under the terms of the GNU General Public License
%as published by the Free Software Foundation; either version 2
%of the License, or (at your option) any later version.

%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.

function  Ip = qtdecomp(img,seuil,mintailleDonnee)

%   QTDECOMP divides a image into four equal-sized square blocks, and
%   then tests each block to see if meets some criterion of homogeneity. If
%   a block meets the criterion, it is not divided any further. If it does
%   not meet the criterion, it is subdivided again into four blocks, and the
%   test criterion is applied to those blocks. This process is repeated
%   iteratively until each block meets the criterion. The result may have
%   blocks of several different sizes.
%
%   S = QTDECOMP(Img,seuil,mintailleDonnee) performs a quadtree decomposition on the intensity image
%   Img, and returns the quadtree structure in the sparse matrix S. Seuil is specified as a value of
%   the critere function. qtdecomp will not produce blocks smaller than mintailleDonnee, even if the
%   resulting blocks do not meet the threshold condition.


% Calcul de la taille de l'image
s = size(img)
L = zeros(s(1),s(2));

% lancement du partitionnement
Ip = qtdecomprec(img, L, 0, seuil,mintailleDonnee);