%Copyright (C) 2005  Tharreau-Taklidi
%This program is free software; you can redistribute it and/or
%modify it under the terms of the GNU General Public License
%as published by the Free Software Foundation; either version 2
%of the License, or (at your option) any later version.

%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.

function  L = qtdecomprec(I, L, label, seuil, tailleDonnee)

% Recuperation de la valeur max des labels
cptLabel = max(max(L));

% Calcul du critere
[ok xmin xmax ymin ymax] = critere(I, L, label, seuil);

% Recuperation du nombre de pixel definnissant le label
zone = sum(sum(L == label));

% si le critere est faux
if( (~ok) & (zone > tailleDonnee) )
    
    % Decoupage de I en quatre sous parties
    L1 = L(xmin : floor((xmin+xmax)/2), ymin : floor((ymin+ymax)/2));
    s1 = size(L1);
    L1 = (double(cptLabel)+1) * ones(s1(1),s1(2));
    
    L2 = L(floor((xmin+xmax)/2) + ((xmin+xmax) & 1) : xmax, ymin : floor((ymin+ymax)/2));
    s2 = size(L2);
    L2 = (double(cptLabel) + 2) * ones(s2(1),s2(2));

    L3 = L(xmin : floor((xmin+xmax)/2), floor((ymin+ymax)/2) + ((ymin+ymax) & 1) : ymax);
    s3 = size(L3);
    L3 = (double(cptLabel) + 3) * ones(s3(1),s3(2));
    
    L4 = L(floor((xmin+xmax)/2) + ((xmin+xmax) & 1) : xmax, floor((ymin+ymax)/2) + ((ymin+ymax) & 1) : ymax);
    s4 = size(L4);
    L4 = (double(cptLabel) + 4) * ones(s4(1),s4(2));
    
    L = [L1 L3;L2 L4];
        
    % On relance la fonction partition sur les quatres sous parties
    L1 = qtdecomprec(I, L, cptLabel+1, seuil,tailleDonnee);
    L = [L1 L3;L2 L4];
    L2 = qtdecomprec(I, L, cptLabel+2, seuil,tailleDonnee);
    L = [L1 L3;L2 L4];
    L3 = qtdecomprec(I, L, cptLabel+3, seuil,tailleDonnee);
    L = [L1 L3;L2 L4];
    L4 = qtdecomprec(I, L, cptLabel+4, seuil,tailleDonnee);
    L = [L1 L3;L2 L4];
     
else
    L = L(xmin : xmax, ymin : ymax);
end
